org.crosswire.bibledesktop.book.install

## Class SitePane

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - org.crosswire.bibledesktop.book.install.SitePane

- All Implemented Interfaces:
    ImageObserver, MenuContainer, Serializable, Accessible

      public class SitePane
      extends JPanel

  A panel for use within a SitesPane to display one set of Books that are installed or could be installed.
  Author:
    Joe Walker, DM Smith
  See Also:
    `for license details.`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) class` | `SitePane.CustomBooksListener` When new books are added we need to reflect the change in this tree.

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private ActionFactory` | `actions` actions are held by this ActionFactory
    `private TextPaneBookMetaDataDisplay` | `display`
    `protected org.crosswire.jsword.book.install.Installer` | `installer` From which we get our list of installable books
    `private JLabel` | `lblDesc`
    `private static long` | `serialVersionUID` Serialization ID
    `private JTree` | `treAvailable`

    - ### Fields inherited from class javax.swing.JComponent

      `accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `SitePane()` For local installations
    `` | `SitePane(org.crosswire.jsword.book.install.Installer bookListInstaller)` For remote installations
    `private` | `SitePane(org.crosswire.jsword.book.install.Installer bookListInstaller, String labelAcronymn)` Internal ctor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `private Component` | `createAvailablePanel(String labelAcronymn, org.crosswire.jsword.book.BookList books)`
    `private Component` | `createPanelActions()`
    `private Component` | `createScrolledTree(org.crosswire.jsword.book.BookList books)`
    `private Component` | `createSelectedPanel()`
    `private Component` | `createSplitPane(Component left, Component right)`
    `private TreeModel` | `createTreeModel(org.crosswire.jsword.book.BookList books)`
    `void` | `doChooseFont()` Get a font for the current selection
    `void` | `doDelete()` Delete the current book
    `void` | `doInstall()` Kick off the installer
    `void` | `doInstallSearch()` Kick off the installer
    `void` | `doRefresh()` Reload and redisplay the list of books
    `void` | `doResetFont()` Resets any font specifically set for this Book / Language
    `void` | `doUnindex()` Delete the current book
    `void` | `doUnlock()` Unlock the current book
    `private org.crosswire.jsword.book.Book` | `getBook(Object anObj)`
    `private org.crosswire.common.util.Language` | `getLanguage(Object anObj)`
    `private void` | `initialize(String labelAcronymn, org.crosswire.jsword.book.BookList books)` Build the GUI components
    `private void` | `readObject(ObjectInputStream is)` Serialization support.
    `protected void` | `selected()` Something has been (un)selected in the tree
    `void` | `setTreeModel(org.crosswire.jsword.book.BookList books)`
    `private void` | `updateDescription()`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### installer

          protected transient org.crosswire.jsword.book.install.Installer installer

      From which we get our list of installable books

    - #### actions

          private transient ActionFactory actions

      actions are held by this ActionFactory

    - #### treAvailable

          private JTree treAvailable

    - #### display

          private transient TextPaneBookMetaDataDisplay display

    - #### lblDesc

          private JLabel lblDesc

    - #### serialVersionUID

          private static final long serialVersionUID

      Serialization ID
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### SitePane

          public SitePane()

      For local installations

    - #### SitePane

          public SitePane(org.crosswire.jsword.book.install.Installer bookListInstaller)

      For remote installations

    - #### SitePane

          private SitePane(org.crosswire.jsword.book.install.Installer bookListInstaller,
                  String labelAcronymn)

      Internal ctor

  - ### Method Detail

    - #### initialize

          private void initialize(String labelAcronymn,
                        org.crosswire.jsword.book.BookList books)

      Build the GUI components

    - #### updateDescription

          private void updateDescription()

    - #### createSplitPane

          private Component createSplitPane(Component left,
                                  Component right)

    - #### createAvailablePanel

          private Component createAvailablePanel(String labelAcronymn,
                                       org.crosswire.jsword.book.BookList books)

    - #### createSelectedPanel

          private Component createSelectedPanel()

    - #### createScrolledTree

          private Component createScrolledTree(org.crosswire.jsword.book.BookList books)

    - #### createTreeModel

          private TreeModel createTreeModel(org.crosswire.jsword.book.BookList books)

    - #### getBook

          private org.crosswire.jsword.book.Book getBook(Object anObj)

    - #### getLanguage

          private org.crosswire.common.util.Language getLanguage(Object anObj)

    - #### createPanelActions

          private Component createPanelActions()

    - #### doDelete

          public void doDelete()

      Delete the current book

    - #### doUnlock

          public void doUnlock()

      Unlock the current book

    - #### doUnindex

          public void doUnindex()

      Delete the current book

    - #### doRefresh

          public void doRefresh()

      Reload and redisplay the list of books

    - #### doInstall

          public void doInstall()

      Kick off the installer

    - #### doInstallSearch

          public void doInstallSearch()

      Kick off the installer

    - #### doChooseFont

          public void doChooseFont()

      Get a font for the current selection

    - #### doResetFont

          public void doResetFont()

      Resets any font specifically set for this Book / Language

    - #### selected

          protected void selected()

      Something has been (un)selected in the tree

    - #### setTreeModel

          public void setTreeModel(org.crosswire.jsword.book.BookList books)

    - #### readObject

          private void readObject(ObjectInputStream is)
                           throws IOException,
                                  ClassNotFoundException

      Serialization support.
      Parameters:
        `is` -
      Throws:
        `IOException`
        `ClassNotFoundException`